Index: /trunk/src/org/expeditee/gui/FrameMouseActions.java
===================================================================
--- /trunk/src/org/expeditee/gui/FrameMouseActions.java	(revision 1101)
+++ /trunk/src/org/expeditee/gui/FrameMouseActions.java	(revision 1102)
@@ -3554,9 +1873,7 @@
 
 		if (FreeItems.getInstance().size() == 2) {
-			if ((FreeItems.getInstance().get(0).isLineEnd() && FreeItems
-					.getInstance().get(1) instanceof Line)
-					|| (FreeItems.getInstance().get(1).isLineEnd() && FreeItems
-							.getInstance().get(0) instanceof Line)) {
-
+			if ((FreeItems.getInstance().get(0).isLineEnd() && FreeItems.getInstance().get(1) instanceof Line) ||
+					(FreeItems.getInstance().get(1).isLineEnd() && FreeItems.getInstance().get(0) instanceof Line))
+			{
 				Line line;
 				if (FreeItems.getInstance().get(0) instanceof Line)
@@ -3582,6 +1899,5 @@
 			}
 
-			FrameKeyboardActions.functionKey(rotationType, 1, arg0
-					.isShiftDown(), arg0.isControlDown());
+			FrameKeyboardActions.functionKey(rotationType, 1, arg0.isShiftDown(), arg0.isControlDown());
 
 		} else if (clicks >= MOUSE_WHEEL_THRESHOLD) {
@@ -3618,6 +1934,5 @@
 	 */
 	public static int getLastMouseButton() {
-		if (_lastMouseClick == null)
-			return MouseEvent.NOBUTTON;
+		if (_lastMouseClick == null) return MouseEvent.NOBUTTON;
 
 		return _lastMouseClick.getButton();
@@ -3625,19 +1940,15 @@
 
 	public static boolean isDelete(int modifiersEx) {
-
-		int onMask = MouseEvent.BUTTON3_DOWN_MASK
-				| MouseEvent.BUTTON2_DOWN_MASK;
+		int onMask = MouseEvent.BUTTON3_DOWN_MASK | MouseEvent.BUTTON2_DOWN_MASK;
 		return (modifiersEx & onMask) == onMask;
 	}
 
 	public static boolean isGetAttributes(int modifiersEx) {
-		int onMask = MouseEvent.BUTTON3_DOWN_MASK
-				| MouseEvent.BUTTON1_DOWN_MASK;
+		int onMask = MouseEvent.BUTTON3_DOWN_MASK | MouseEvent.BUTTON1_DOWN_MASK;
 		return (modifiersEx & onMask) == onMask;
 	}
 
 	public static boolean isTwoClickNoOp(int modifiersEx) {
-		int onMask = MouseEvent.BUTTON2_DOWN_MASK
-				| MouseEvent.BUTTON1_DOWN_MASK;
+		int onMask = MouseEvent.BUTTON2_DOWN_MASK | MouseEvent.BUTTON1_DOWN_MASK;
 		return (modifiersEx & onMask) == onMask;
 	}
@@ -3705,8 +2016,4 @@
 	}
 
-	public static Item getlastHighlightedItem() {
-		return _lastHighlightedItem;
-	}
-
 	public static Point getPosition() {
 		return new Point(getX(), getY());
@@ -3722,3 +2029,9 @@
 		getInstance().refreshHighlights();
 	}
+
+	@Override
+	public void onGesture(Gesture gesture) {
+		// TODO Auto-generated method stub
+		
+	}
 }
Index: /trunk/src/org/expeditee/gui/FrameUtils.java
===================================================================
--- /trunk/src/org/expeditee/gui/FrameUtils.java	(revision 1101)
+++ /trunk/src/org/expeditee/gui/FrameUtils.java	(revision 1102)
@@ -19,8 +19,4 @@
 package org.expeditee.gui;
 
-import java.awt.Color;
-import java.awt.Point;
-import java.awt.Polygon;
-import java.awt.Rectangle;
 import java.io.File;
 import java.io.FileInputStream;
@@ -44,4 +40,10 @@
 import java.util.zip.ZipEntry;
 
+import org.expeditee.core.Colour;
+import org.expeditee.core.Point;
+import org.expeditee.core.bounds.AxisAlignedBoxBounds;
+import org.expeditee.core.bounds.PolygonBounds;
+import org.expeditee.gio.EcosystemManager;
+import org.expeditee.gio.gesture.StandardGestureActions;
 import org.expeditee.items.Circle;
 import org.expeditee.items.Dot;
@@ -60,5 +62,5 @@
 import org.expeditee.items.XRayable;
 import org.expeditee.items.widgets.ButtonWidget;
-import org.expeditee.items.widgets.InteractiveWidget;
+import org.expeditee.items.widgets.Widget;
 import org.expeditee.items.widgets.InteractiveWidgetInitialisationFailedException;
 import org.expeditee.items.widgets.InteractiveWidgetNotAvailableException;
Index: /trunk/src/org/expeditee/gui/FrameUtils.java
===================================================================
--- /trunk/src/org/expeditee/gui/FrameUtils.java	(revision 1101)
+++ /trunk/src/org/expeditee/gui/FrameUtils.java	(revision 1102)
@@ -1840,7 +1839,7 @@
 				String res = "org/expeditee/assets/resources/";
 				int resLength = res.length();
-				
+
 				ZipEntry ze;
-				
+
 				while(jarEntries.hasMoreElements()) {
 					ze = jarEntries.nextElement();
@@ -1850,7 +1849,7 @@
 					File out = new File(FrameIO.PARENT_FOLDER + ze.getName().substring(resLength));
 					// System.out.println("Didn't crash here " + out.getPath());
-//					if(out.exists()) {
-//						continue;
-//					}
+					//					if(out.exists()) {
+					//						continue;
+					//					}
 					if(ze.isDirectory()) {
 						// System.out.println(out.getPath() + " IS DIRECTORY");
@@ -1881,6 +1880,6 @@
 					}
 				}
-				
-			// Copy files from the source folder to the profile folder
+
+				// Copy files from the source folder to the profile folder
 			} else if (docURL.getProtocol().equals("bundleresource")) {
 				final URLConnection urlConnection = docURL.openConnection();
@@ -1899,42 +1898,44 @@
 	}
 
-    private static void extractResourcesFromFolder(File folder) throws IOException {
-	LinkedList<File> items = new LinkedList<File>();
-	items.addAll(Arrays.asList(folder.listFiles()));
-	LinkedList<File> files = new LinkedList<File>();
-	String res = "org" + File.separator + "expeditee" + File.separator + "assets" + File.separator + "resources";
-	int resLength = res.length();
-	
-	while (items.size() > 0) {
-		File file = items.remove(0);
-		if(file.isFile()) {
-			if(!file.getName().contains(".svn")) {
-				files.add(file);
-			}
-		} else {
-			if (!file.getName().contains(".svn")) {
-				items.addAll(Arrays.asList(file.listFiles()));
-			}
-		}
-	}
-	for (File file : files) {
-		System.out.println(file.getPath());
-		File out = new File(FrameIO.PARENT_FOLDER + file.getPath().substring(file.getPath().indexOf(res) + resLength));
-//		if(out.exists()) {
-//			continue;
-//		}
-		copyFile(file, out, true);
-	}
-    }
-    
-    /**
-     * @param src
-     * @param dst
-     * @throws IOException
-     */
-    public static void copyFile(File src, File dst, boolean overWrite) throws IOException {
-    	if(!overWrite && dst.exists())
-    		return;
-    	dst.getParentFile().mkdirs();
+	private static void extractResourcesFromFolder(File folder) throws IOException
+	{
+		LinkedList<File> items = new LinkedList<File>();
+		items.addAll(Arrays.asList(folder.listFiles()));
+		LinkedList<File> files = new LinkedList<File>();
+		String res = "org" + File.separator + "expeditee" + File.separator + "assets" + File.separator + "resources";
+		int resLength = res.length();
+
+		while (items.size() > 0) {
+			File file = items.remove(0);
+			if(file.isFile()) {
+				if(!file.getName().contains(".svn")) {
+					files.add(file);
+				}
+			} else {
+				if (!file.getName().contains(".svn")) {
+					items.addAll(Arrays.asList(file.listFiles()));
+				}
+			}
+		}
+		for (File file : files) {
+			System.out.println(file.getPath());
+			File out = new File(FrameIO.PARENT_FOLDER + file.getPath().substring(file.getPath().indexOf(res) + resLength));
+			//		if(out.exists()) {
+			//			continue;
+			//		}
+			copyFile(file, out, true);
+		}
+	}
+
+	/**
+	 * @param src
+	 * @param dst
+	 * @throws IOException
+	 */
+	public static void copyFile(File src, File dst, boolean overWrite) throws IOException
+	{
+		if(!overWrite && dst.exists()) return;
+		
+		dst.getParentFile().mkdirs();
 		FileOutputStream fOut = null;
 		FileInputStream fIn = null;
@@ -1959,21 +1960,23 @@
 			}
 		}
-    }
-
-    public static Text getLastEdited() {
-	return LastEdited;
-    }
-
-    public static Collection<Text> getCurrentTextItems() {
-	Collection<Text> currentTextItems = new LinkedHashSet<Text>();
-	Collection<Item> currentItems = getCurrentItems(null);
-	if (currentItems != null) {
-	    for (Item i : getCurrentItems(null)) {
-		if (i instanceof Text && !i.isLineEnd()) {
-		    currentTextItems.add((Text) i);
-		}
-	    }
-	}
-	return currentTextItems;
-    }
+	}
+
+	public static Text getLastEdited()
+	{
+		return LastEdited;
+	}
+
+	public static Collection<Text> getCurrentTextItems()
+	{
+		Collection<Text> currentTextItems = new LinkedHashSet<Text>();
+		Collection<Item> currentItems = getCurrentItems(null);
+		if (currentItems != null) {
+			for (Item i : getCurrentItems(null)) {
+				if (i instanceof Text && !i.isLineEnd()) {
+					currentTextItems.add((Text) i);
+				}
+			}
+		}
+		return currentTextItems;
+	}
 }
Index: /trunk/src/org/expeditee/gui/FreeItems.java
===================================================================
--- /trunk/src/org/expeditee/gui/FreeItems.java	(revision 1101)
+++ /trunk/src/org/expeditee/gui/FreeItems.java	(revision 1102)
@@ -19,5 +19,4 @@
 package org.expeditee.gui;
 
-import java.awt.Polygon;
 import java.util.ArrayList;
 import java.util.Collection;
@@ -29,4 +28,5 @@
 import java.util.Map;
 
+import org.expeditee.core.bounds.PolygonBounds;
 import org.expeditee.items.Dot;
 import org.expeditee.items.Item;
@@ -42,17 +42,22 @@
 	private static FreeItems _cursor = new FreeItems();
 
-	private FreeItems() {
-	}
-
-	public static FreeItems getCursor() {
+	public static FreeItems getCursor()
+	{
 		return _cursor;
 	}
 	
-	public static FreeItems getInstance() {
+	public static FreeItems getInstance()
+	{
 		return _instance;
 	}
 
-	@Override
-	public void clear() {
+	/** Singleton class (although there are two of them). */
+	private FreeItems()
+	{
+	}
+	
+	@Override
+	public void clear()
+	{
 		for (Item i : this) {
 			i.invalidateAll();
@@ -63,5 +68,6 @@
 
 	@Override
-	public Item remove(int index) {
+	public Item remove(int index)
+	{
 		Item i = get(index);
 		remove(i);
@@ -70,9 +76,11 @@
 
 	@Override
-	public boolean remove(Object o) {
+	public boolean remove(Object o)
+	{
 		if (o instanceof Item) {
 			((Item) o).invalidateAll();
 			((Item) o).invalidateFill();
 		}
+		
 		return super.remove(o);
 	}
@@ -84,5 +92,6 @@
 	 * @return true if at least one item is attached to the cursor.
 	 */
-	public static boolean itemsAttachedToCursor() {
+	public static boolean hasItemsAttachedToCursor()
+	{
 		return getInstance().size() > 0;
 	}
@@ -94,24 +103,26 @@
 	 *         attached are text items.
 	 */
-	public static boolean textOnlyAttachedToCursor() {
-		if (!itemsAttachedToCursor())
-			return false;
-		for (Item i : getInstance()) {
-			if (!(i instanceof Text)) {
-				return false;
-			}
-		}
+	public static boolean textOnlyAttachedToCursor()
+	{
+		if (!hasItemsAttachedToCursor()) return false;
+		
+		for (Item i : getInstance()) {
+			if (!(i instanceof Text)) return false;
+		}
+		
 		return true;
 	}
 
-	public static Item getItemAttachedToCursor() {
-		if (itemsAttachedToCursor())
-			return getInstance().get(0);
+	public static Item getItemAttachedToCursor()
+	{
+		if (hasItemsAttachedToCursor()) return getInstance().get(0);
+		
 		return null;
 	}
 
-	public static Text getTextAttachedToCursor() {
-		if (textOnlyAttachedToCursor())
-			return (Text) getInstance().get(0);
+	public static Text getTextAttachedToCursor()
+	{
+		if (textOnlyAttachedToCursor()) return (Text) getInstance().get(0);
+		
 		return null;
 	}
@@ -121,10 +132,10 @@
 	 * @return the list of free text items
 	 */
-	public static Collection<Text> getTextItems() {
+	public static Collection<Text> getTextItems()
+	{
 		Collection<Text> textItems = new LinkedList<Text>();
-		for (Item i : getInstance()) {
-			if (i instanceof Text) {
-				textItems.add((Text) i);
-			}
+		
+		for (Item i : getInstance()) {
+			if (i instanceof Text) textItems.add((Text) i);
 		}
 
@@ -132,12 +143,13 @@
 	}
 
-	public static Map<String, Collection<String>> getGroupedText() {
+	public static Map<String, Collection<String>> getGroupedText()
+	{
 		Map<String, Collection<String>> groupedText = new HashMap<String, Collection<String>>();
+		
 		// Go throught the lineEnds
 		Collection<Item> addedItems = new HashSet<Item>();
 		for (Item i : getInstance()) {
-			if (!(i instanceof Text) || !i.isLineEnd()) {
-				continue;
-			}
+			if (!(i instanceof Text) || !i.isLineEnd()) continue;
+			
 			// Check for text inside the box
 			Collection<String> textList = new LinkedList<String>();
@@ -146,8 +158,10 @@
 				addedItems.add(enclosed);
 			}
+			
 			if (textList.size() > 0) {
 				groupedText.put(i.getText(), textList);
 			}
 		}
+		
 		// Now add the items that were not contained in any of the boxes
 		Collection<String> outsideList = new LinkedList<String>();
@@ -157,4 +171,5 @@
 			}
 		}
+		
 		groupedText.put("", outsideList);
 
@@ -169,6 +184,8 @@
 	 * @return
 	 */
-	private Collection<Text> getTextWithin(Item lineEnd) {
-		Polygon poly = lineEnd.getEnclosedShape();
+	private Collection<Text> getTextWithin(Item lineEnd)
+	{
+		PolygonBounds poly = lineEnd.getEnclosedShape();
+		
 		Collection<Text> results = new LinkedHashSet<Text>();
 		for (Item i : this) {
@@ -177,18 +194,23 @@
 			}
 		}
+		
 		return results;
 	}
 
-	public static boolean hasCursor() {
+	public static boolean hasCursor()
+	{
 		return getCursor().size() > 0;
 	}
 
-	public static void setCursor(Collection<Item> cursor) {
+	public static void setCursor(Collection<Item> cursor)
+	{
 		_cursor.clear();
 		_cursor.addAll(cursor);
 	}
 	
-	public static boolean hasMultipleVisibleItems() {
+	public static boolean hasMultipleVisibleItems()
+	{
 		List<Item> toCount = new LinkedList<Item>(getInstance());
+		
 		int c = 0;
 		while(!toCount.isEmpty()) {
@@ -199,10 +221,44 @@
 			}
 		}
+		
 		return false;
 	}
 	
-	public static boolean isDrawingPolyLine() {
+	public static boolean isDrawingPolyLine()
+	{
 		List<Item> tmp = getInstance();
+		
 		return tmp.size() == 2 && tmp.get(0) instanceof Dot && tmp.get(1) instanceof Line;
 	}
+
+	/**
+	 * Checks if lines are being rubber banded.
+	 * 
+	 * @return true if the user is rubberBanding one or more lines
+	 */
+	public static boolean rubberBanding()
+	{
+		if (getInstance().size() != 2) return false;
+
+		// if rubber-banding, there will be 1 line end and the rest will be lines
+		boolean foundLineEnd = false;
+		for (Item i : getInstance()) {
+			if (i.isLineEnd()) {
+				if (foundLineEnd) return false;
+				foundLineEnd = true;
+			} else if (!(i instanceof Line) || !i.isVisible()) {
+				return false;
+			}
+		}
+		
+		return true;
+	}
+	
+	@Override
+	public FreeItems clone()
+	{
+		FreeItems ret = new FreeItems();
+		ret.addAll(this);
+		return ret;
+	}
 }
Index: /trunk/src/org/expeditee/gui/FunctionKey.java
===================================================================
--- /trunk/src/org/expeditee/gui/FunctionKey.java	(revision 1101)
+++ /trunk/src/org/expeditee/gui/FunctionKey.java	(revision 1102)
@@ -19,7 +19,18 @@
 package org.expeditee.gui;
 
-//these numbers correspond to the Function Key numbers (0 = Escape key)
+/** Enumerates the Function Key numbers (0 = Escape key) */
 public enum FunctionKey {
-	DropDown, SizeUp, SizeDown, ChangeColor, ToggleAnnotation, InsertDate, NewFrameset, ChangeFontStyle, ChangeFontFamily,
-	AudienceMode, XRayMode, Save, Refresh;
+	DropDown,
+	SizeUp,
+	SizeDown,
+	ChangeColor,
+	ToggleAnnotation,
+	InsertDate,
+	NewFrameset,
+	ChangeFontStyle,
+	ChangeFontFamily,
+	AudienceMode,
+	XRayMode,
+	Save,
+	Refresh
 }
Index: /trunk/src/org/expeditee/gui/Help.java
===================================================================
--- /trunk/src/org/expeditee/gui/Help.java	(revision 1101)
+++ /trunk/src/org/expeditee/gui/Help.java	(revision 1102)
@@ -26,9 +26,8 @@
 import org.expeditee.items.Picture;
 import org.expeditee.items.Text;
-import org.expeditee.items.widgets.InteractiveWidget;
+import org.expeditee.items.widgets.Widget;
 import org.expeditee.items.widgets.WidgetCorner;
 import org.expeditee.items.widgets.WidgetEdge;
 import org.expeditee.settings.experimental.ExperimentalFeatures;
-
 
 public class Help {
@@ -120,4 +119,6 @@
 			if((mod & shift) == 0)return "Extend line";
 			break;
+		default:
+			break;
 		}
 		if((other & cursor) != 0) return "Stamp copy";
@@ -152,4 +153,6 @@
 			}
 			break;
+		default:
+			break;
 		}
 		return "Delete";
@@ -165,4 +168,6 @@
 			if((other & cursor) == 0) return "Select text region";
 			break;
+		default:
+			break;
 		}
 		return null;
@@ -174,4 +179,6 @@
 		case text:
 			if((other & cursor) == 0) return "Cut text region";
+		default:
+			break;
 		}
 		return null;
@@ -187,4 +194,6 @@
 		case text:
 			if((other & cursor) == 0) return "Copy text region";
+		default:
+			break;
 		}
 		return null;
@@ -192,9 +201,10 @@
 	
 	
-	public static void updateStatus() {
+	public static void updateStatus(boolean controlDown, boolean shiftDown)
+	{
 		Item current = FrameUtils.getCurrentItem();
 		Collection<Item> currents;
 		Context context;
-		InteractiveWidget iw = null;
+		Widget iw = null;
 		if(current != null) {
 			if(current instanceof Line) {
@@ -232,9 +242,9 @@
 			}
 		}
-		int mod = (FrameMouseActions.isControlDown() ? control : 0) | (FrameMouseActions.isShiftDown() ? shift : 0);
+		int mod = (controlDown ? control : 0) | (shiftDown ? shift : 0);
 		int other = (ExperimentalFeatures.MousePan.get() ? panning : 0) |
 				(current != null && current.hasAction() ? action : 0)|
 				(current != null && current.hasLink() ? link : 0) |
-				(FreeItems.itemsAttachedToCursor() ? cursor : 0);
+				(FreeItems.hasItemsAttachedToCursor() ? cursor : 0);
 		String status = "";
 		
@@ -264,5 +274,4 @@
 		}
 		
-		
 		MessageBay.setStatus(status);
 	}
